from itertools import permutations

def calculate_distance(x1, y1, x2, y2):
    return ((x2 - x1) ** 2 + (y2 - y1) ** 2) ** 0.5

n = int(input())
points = []
for i in range(n):
    x, y = map(int, input().split())
    points.append((x, y))

n = len(points)
distances = []

for i in permutations(range(n)):
    distance = 0
    for j in range(1, n):
        distance += calculate_distance(points[i[j - 1]][0], points[i[j - 1]][1], points[i[j]][0], points[i[j]][1])
    distances.append(distance)

print(min(distances))
